"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("@rawmodel/utils");
class Handler {
    constructor(config) {
        Object.defineProperty(this, '$config', {
            value: Object.assign({}, config),
            enumerable: false,
        });
    }
    handle(error, recipes = []) {
        return __awaiter(this, void 0, void 0, function* () {
            const codes = [];
            for (const recipe of recipes) {
                const condition = recipe.condition;
                if (condition) {
                    const result = yield condition.call(this.$config.ctx, error, recipe);
                    if (!result) {
                        continue;
                    }
                }
                const context = utils_1.realize(this.$config.ctx);
                const isMatch = yield Promise.all((utils_1.isArray(error) ? error : [error])
                    .map((v) => recipe.handler.call(context, v, recipe))).then((r) => r.indexOf(false) === -1);
                if (isMatch) {
                    codes.push(recipe.code);
                    if (utils_1.realize(this.$config.failFast)) {
                        break;
                    }
                }
            }
            return codes;
        });
    }
}
exports.Handler = Handler;
//# sourceMappingURL=handler.js.map